"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HttpError = void 0;
class HttpError extends Error {
    constructor(code, message, errors = []) {
        super(message);
        this._errors = [];
        this._code = code;
        this._errors = errors;
    }
    get code() {
        return this._code;
    }
    get errors() {
        return [...this._errors];
    }
    toJSON() {
        return {
            code: this.code,
            message: this.message,
            errors: this.errors,
        };
    }
}
exports.HttpError = HttpError;
//# sourceMappingURL=HttpError.js.map